$| = 1;
our
$Level
= 1;
my
$test
= 1;
my
$planned
;
my
$noplan
;
my
$Perl
;
$::IS_ASCII =
ord
'A'
== 65;
$::IS_EBCDIC =
ord
'A'
== 193;
our
$TODO
= 0;
our
$NO_ENDING
= 0;
our
$Tests_Are_Passing
= 1;
sub
_print {
local
($\, $", $,) = (
undef
,
' '
,
''
);
print
STDOUT
@_
;
}
sub
_print_stderr {
local
($\, $", $,) = (
undef
,
' '
,
''
);
print
STDERR
@_
;
}
sub
plan {
my
$n
;
if
(
@_
== 1) {
$n
=
shift
;
if
(
$n
eq
'no_plan'
) {
undef
$n
;
$noplan
= 1;
}
}
else
{
my
%plan
=
@_
;
$plan
{skip_all} and skip_all(
$plan
{skip_all});
$n
=
$plan
{tests};
}
_print
"1..$n\n"
unless
$noplan
;
$planned
=
$n
;
}
sub
done_testing {
my
$n
=
$test
- 1;
$n
=
shift
if
@_
;
_print
"1..$n\n"
;
$planned
=
$n
;
}
END {
my
$ran
=
$test
- 1;
if
(!
$NO_ENDING
) {
if
(
defined
$planned
&&
$planned
!=
$ran
) {
_print_stderr
"# Looks like you planned $planned tests but ran $ran.\n"
;
}
elsif
(
$noplan
) {
_print
"1..$ran\n"
;
}
}
}
sub
_diag {
return
unless
@_
;
my
@mess
= _comment(
@_
);
$TODO
? _print(
@mess
) : _print_stderr(
@mess
);
}
sub
diag {
_diag(
@_
);
}
sub
note {
return
unless
@_
;
_print( _comment(
@_
) );
}
sub
is_miniperl {
return
!
defined
&DynaLoader::boot_DynaLoader
;
}
sub
set_up_inc {
@INC
= ()
unless
is_miniperl;
unshift
@INC
,
@_
;
}
sub
_comment {
return
map
{ /^
map
{
split
/\n/ }
@_
;
}
sub
_have_dynamic_extension {
my
$extension
=
shift
;
unless
(
eval
{
require
Config; 1}) {
warn
"test.pl had problems loading Config: $@"
;
return
1;
}
$extension
=~ s!::!/!g;
return
1
if
(
$Config::Config
{extensions} =~ /\b
$extension
\b/);
}
sub
skip_all {
if
(
@_
) {
_print
"1..0 # Skip @_\n"
;
}
else
{
_print
"1..0\n"
;
}
exit
(0);
}
sub
skip_all_if_miniperl {
skip_all(
@_
)
if
is_miniperl();
}
sub
skip_all_without_dynamic_extension {
my
(
$extension
) =
@_
;
skip_all(
"no dynamic loading on miniperl, no $extension"
)
if
is_miniperl();
return
if
&_have_dynamic_extension
;
skip_all(
"$extension was not built"
);
}
sub
skip_all_without_perlio {
skip_all(
'no PerlIO'
)
unless
PerlIO::Layer->find(
'perlio'
);
}
sub
skip_all_without_config {
unless
(
eval
{
require
Config; 1}) {
warn
"test.pl had problems loading Config: $@"
;
return
;
}
foreach
(
@_
) {
next
if
$Config::Config
{
$_
};
my
$key
=
$_
;
$key
=~ s/^
use
//;
$key
=~ s/^d_//;
skip_all(
"no $key"
);
}
}
sub
skip_all_without_unicode_tables {
if
(is_miniperl()) {
skip_all_if_miniperl(
"Unicode tables not built yet"
)
unless
eval
'require "unicore/UCD.pl"'
;
}
}
sub
find_git_or_skip {
my
(
$source_dir
,
$reason
);
if
(
$ENV
{CONTINUOUS_INTEGRATION} &&
$ENV
{WORKSPACE} ) {
$source_dir
=
$ENV
{WORKSPACE};
if
( -d
"${source_dir}/.git"
) {
$ENV
{GIT_DIR} =
"${source_dir}/.git"
;
return
$source_dir
;
}
}
if
(-d
'.git'
) {
$source_dir
=
'.'
;
}
elsif
(-l
'MANIFEST'
&& -l
'AUTHORS'
) {
my
$where
=
readlink
'MANIFEST'
;
die
"Can't readlink MANIFEST: $!"
unless
defined
$where
;
die
"Confusing symlink target for MANIFEST, '$where'"
unless
$where
=~ s!/MANIFEST\z!!;
if
(-d
"$where/.git"
) {
if
(
exists
$ENV
{GIT_DIR}) {
diag(
"Found source tree at $where, but \$ENV{GIT_DIR} is $ENV{GIT_DIR}. Not changing it"
);
}
else
{
note(
"Found source tree at $where, setting \$ENV{GIT_DIR}"
);
$ENV
{GIT_DIR} =
"$where/.git"
;
}
$source_dir
=
$where
;
}
}
elsif
(
exists
$ENV
{GIT_DIR} || -f
'.git'
) {
my
$commit
=
'8d063cd8450e59ea1c611a2f4f5a21059a2804f1'
;
my
$out
= `git rev-parse --verify --quiet
'$commit^{commit}'
`;
chomp
$out
;
if
(
$out
eq
$commit
) {
$source_dir
=
'.'
}
}
if
(
$ENV
{
'PERL_BUILD_PACKAGING'
}) {
$reason
=
'PERL_BUILD_PACKAGING is set'
;
}
elsif
(
$source_dir
) {
my
$version_string
= `git --version`;
if
(
defined
$version_string
&&
$version_string
=~ /\Agit version (\d+\.\d+\.\d+)(.*)/) {
return
$source_dir
if
eval
"v$1 ge v1.5.0"
;
$reason
=
"in git checkout, but git version '$1$2' too old"
;
}
else
{
$reason
=
"in git checkout, but cannot run git"
;
}
}
else
{
$reason
=
'not being run from a git checkout'
;
}
skip_all(
$reason
)
if
$_
[0] &&
$_
[0] eq
'all'
;
skip(
$reason
,
@_
);
}
sub
BAIL_OUT {
my
(
$reason
) =
@_
;
_print(
"Bail out! $reason\n"
);
exit
255;
}
sub
_ok {
my
(
$pass
,
$where
,
$name
,
@mess
) =
@_
;
my
$out
;
if
(
$name
) {
$name
=~ s/
$out
=
$pass
?
"ok $test - $name"
:
"not ok $test - $name"
;
}
else
{
$out
=
$pass
?
"ok $test - [$where]"
:
"not ok $test - [$where]"
;
}
if
(
$TODO
) {
$out
=
$out
.
" # TODO $TODO"
;
}
else
{
$Tests_Are_Passing
= 0
unless
$pass
;
}
_print
"$out\n"
;
if
(
$pass
) {
note
@mess
;
}
else
{
my
$msg
=
"# Failed test $test - "
;
$msg
.=
"$name "
if
$name
;
$msg
.=
"$where\n"
;
_diag
$msg
;
_diag
@mess
;
}
$test
=
$test
+ 1;
return
$pass
;
}
sub
_where {
my
(
undef
,
$filename
,
$lineno
) =
caller
(
$Level
);
return
"at $filename line $lineno"
;
}
sub
ok ($@) {
my
(
$pass
,
$name
,
@mess
) =
@_
;
_ok(
$pass
, _where(),
$name
,
@mess
);
}
sub
_q {
my
$x
=
shift
;
return
'undef'
unless
defined
$x
;
my
$q
=
$x
;
$q
=~ s/\\/\\\\/g;
$q
=~ s/
'/\\'
/g;
return
"'$q'"
;
}
sub
_qq {
my
$x
=
shift
;
return
defined
$x
?
'"'
. display (
$x
) .
'"'
:
'undef'
;
};
my
$chars_template
=
defined
(
eval
{
pack
"W*"
, 90 }) ?
"W*"
:
"U*"
;
eval
'sub re::is_regexp { ref($_[0]) eq "Regexp" }'
if
!
defined
&re::is_regexp
;
my
%backslash_escape
;
foreach
my
$x
(
split
//,
'enrtfa\\\'"'
) {
$backslash_escape
{
ord
eval
"\"\\$x\""
} =
"\\$x"
;
}
sub
display {
my
@result
;
foreach
my
$x
(
@_
) {
if
(
defined
$x
and not
ref
$x
) {
my
$y
=
''
;
foreach
my
$c
(
unpack
(
$chars_template
,
$x
)) {
if
(
$c
> 255) {
$y
=
$y
.
sprintf
"\\x{%x}"
,
$c
;
}
elsif
(
$backslash_escape
{
$c
}) {
$y
=
$y
.
$backslash_escape
{
$c
};
}
elsif
(
$c
<
ord
" "
) {
$y
=
$y
.
sprintf
"\\%03o"
,
$c
;
}
elsif
(
chr
$c
=~ /[[:
print
:]]/a) {
$y
=
$y
.
chr
$c
;
}
else
{
$y
=
$y
.
sprintf
"\\x%02X"
,
$c
;
}
}
$x
=
$y
;
}
return
$x
unless
wantarray
;
push
@result
,
$x
;
}
return
@result
;
}
sub
display_rx {
my
(
$str
) =
@_
;
my
$escaped
=
""
;
my
@cp
;
for
my
$i
(0 ..
length
(
$str
)-1) {
my
$char
=
substr
(
$str
,
$i
,1);
push
@cp
, utf8::native_to_unicode(
ord
(
$char
));
}
while
(
@cp
) {
my
$ord
=
shift
@cp
;
if
(32 <=
$ord
<= 126 and
$ord
!= 37) {
$escaped
.=
chr
(utf8::unicode_to_native(
$ord
));
}
else
{
my
@cp_hex
=
sprintf
"%02x"
,
$ord
;
while
(
@cp
and
$cp
[0] != 37 and (
$cp
[0]<32 or
$cp
[0]>126)) {
push
@cp_hex
,
sprintf
"%02x"
,
shift
@cp
;
}
$escaped
.=
sprintf
"%%x{%s}"
,
join
"+"
,
@cp_hex
;
}
}
return
$escaped
;
}
sub
is ($$@) {
my
(
$got
,
$expected
,
$name
,
@mess
) =
@_
;
my
$pass
;
if
( !
defined
$got
|| !
defined
$expected
) {
$pass
= !
defined
$got
&& !
defined
$expected
;
}
else
{
$pass
=
$got
eq
$expected
;
}
unless
(
$pass
) {
unshift
(
@mess
,
"# got "
._qq(
$got
).
"\n"
,
"# expected "
._qq(
$expected
).
"\n"
);
if
(
defined
$got
and
defined
$expected
and
(
length
(
$got
)>20 or
length
(
$expected
)>20))
{
my
$p
= 0;
$p
++
while
substr
(
$got
,
$p
,1) eq
substr
(
$expected
,
$p
,1);
push
@mess
,
"# diff at $p\n"
;
push
@mess
,
"# after "
._qq(
substr
(
$got
,
$p
< 40 ? 0 :
$p
- 40,
$p
< 40 ?
$p
: 40)) .
"\n"
;
push
@mess
,
"# have "
._qq(
substr
(
$got
,
$p
,40)).
"\n"
;
push
@mess
,
"# want "
._qq(
substr
(
$expected
,
$p
,40)).
"\n"
;
}
}
_ok(
$pass
, _where(),
$name
,
@mess
);
}
sub
isnt ($$@) {
my
(
$got
,
$isnt
,
$name
,
@mess
) =
@_
;
my
$pass
;
if
( !
defined
$got
|| !
defined
$isnt
) {
$pass
=
defined
$got
||
defined
$isnt
;
}
else
{
$pass
=
$got
ne
$isnt
;
}
unless
(
$pass
) {
unshift
(
@mess
,
"# it should not be "
._qq(
$got
).
"\n"
,
"# but it is.\n"
);
}
_ok(
$pass
, _where(),
$name
,
@mess
);
}
sub
cmp_ok ($$$@) {
my
(
$got
,
$type
,
$expected
,
$name
,
@mess
) =
@_
;
my
$pass
;
{
local
$^W = 0;
local
($@,$!);
$pass
=
eval
"\$got $type \$expected"
;
}
unless
(
$pass
) {
if
(
$got
eq
$expected
and
$type
!~
tr
/a-z//) {
unshift
@mess
,
"# $got - $expected = "
. (
$got
-
$expected
) .
"\n"
;
}
unshift
(
@mess
,
"# got "
._qq(
$got
).
"\n"
,
"# expected $type "
._qq(
$expected
).
"\n"
);
}
_ok(
$pass
, _where(),
$name
,
@mess
);
}
sub
within ($$$@) {
my
(
$got
,
$expected
,
$range
,
$name
,
@mess
) =
@_
;
my
$pass
;
if
(!
defined
$got
or !
defined
$expected
or !
defined
$range
) {
}
elsif
(
$got
!~
tr
/0-9// or
$expected
!~
tr
/0-9// or
$range
!~
tr
/0-9//) {
unshift
@mess
,
"# got, expected and range must be numeric\n"
;
}
elsif
(
$range
< 0) {
unshift
@mess
,
"# range must not be negative\n"
;
}
elsif
(
$range
== 0) {
$pass
=
$got
==
$expected
;
}
elsif
(
$expected
== 0) {
$pass
= (
$got
<=
$range
) && (
$got
>= -
$range
);
}
else
{
my
$diff
=
$got
-
$expected
;
$pass
=
abs
(
$diff
/
$expected
) <
$range
;
}
unless
(
$pass
) {
if
(
$got
eq
$expected
) {
unshift
@mess
,
"# $got - $expected = "
. (
$got
-
$expected
) .
"\n"
;
}
unshift
@mess
,
"# got "
._qq(
$got
).
"\n"
,
"# expected "
._qq(
$expected
).
" (within "
._qq(
$range
).
")\n"
;
}
_ok(
$pass
, _where(),
$name
,
@mess
);
}
sub
like ($$@) { like_yn (0,
@_
) };
sub
unlike ($$@) { like_yn (1,
@_
) };
sub
like_yn ($$$@) {
my
(
$flip
,
undef
,
$expected
,
$name
,
@mess
) =
@_
;
unless
(re::is_regexp(
$expected
)) {
die
"PANIC: The value '$expected' isn't a regexp. The like() function needs a qr// pattern, not a string"
;
}
my
$pass
= (
$flip
) ?
$_
[1] !~ /
$expected
/ :
$_
[1] =~ /
$expected
/;
unless
(
$pass
) {
my
$display_got
= display(
$_
[1]);
my
$display_expected
= display(
$expected
);
unshift
(
@mess
,
"# got '$display_got'\n"
,
$flip
?
"# expected !~ /$display_expected/\n"
:
"# expected /$display_expected/\n"
);
}
local
$Level
=
$Level
+ 1;
_ok(
$pass
, _where(),
$name
,
@mess
);
}
sub
refcount_is {
my
(
undef
,
$expected
,
$name
,
@mess
) =
@_
;
my
$got
=
&Internals::SvREFCNT
(
$_
[0]) + 1;
my
$pass
=
$got
==
$expected
;
unless
(
$pass
) {
unshift
@mess
,
"# got $got references\n"
.
"# expected $expected\n"
;
}
_ok(
$pass
, _where(),
$name
,
@mess
);
}
sub
pass {
_ok(1,
''
,
@_
);
}
sub
fail {
_ok(0, _where(),
@_
);
}
sub
curr_test {
$test
=
shift
if
@_
;
return
$test
;
}
sub
next_test {
my
$retval
=
$test
;
$test
=
$test
+ 1;
$retval
;
}
sub
skip {
my
$why
=
shift
;
my
$n
=
@_
?
shift
: 1;
my
$bad_swap
;
my
$both_zero
;
{
local
$^W = 0;
$bad_swap
=
$why
> 0 &&
$n
== 0;
$both_zero
=
$why
== 0 &&
$n
== 0;
}
if
(
$bad_swap
||
$both_zero
||
@_
) {
my
$arg
=
"'$why', '$n'"
;
if
(
@_
) {
$arg
.=
join
(
", "
,
''
,
map
{
qq['$_']
}
@_
);
}
die
qq[$0: expected skip(why, count), got skip($arg)\n]
;
}
for
(1..
$n
) {
_print
"ok $test # skip $why\n"
;
$test
=
$test
+ 1;
}
local
$^W = 0;
last
SKIP;
}
sub
skip_if_miniperl {
skip(
@_
)
if
is_miniperl();
}
sub
skip_without_dynamic_extension {
my
$extension
=
shift
;
skip(
"no dynamic loading on miniperl, no extension $extension"
,
@_
)
if
is_miniperl();
return
if
&_have_dynamic_extension
(
$extension
);
skip(
"extension $extension was not built"
,
@_
);
}
sub
todo_skip {
my
$why
=
shift
;
my
$n
=
@_
?
shift
: 1;
for
(1..
$n
) {
_print
"not ok $test # TODO & SKIP $why\n"
;
$test
=
$test
+ 1;
}
local
$^W = 0;
last
TODO;
}
sub
eq_array {
my
(
$ra
,
$rb
) =
@_
;
return
0
unless
$#$ra
==
$#$rb
;
for
my
$i
(0..
$#$ra
) {
next
if
!
defined
$ra
->[
$i
] && !
defined
$rb
->[
$i
];
return
0
if
!
defined
$ra
->[
$i
];
return
0
if
!
defined
$rb
->[
$i
];
return
0
unless
$ra
->[
$i
] eq
$rb
->[
$i
];
}
return
1;
}
sub
eq_hash {
my
(
$orig
,
$suspect
) =
@_
;
my
$fail
;
while
(
my
(
$key
,
$value
) =
each
%$suspect
) {
$key
=
""
.
$key
;
if
(
exists
$orig
->{
$key
}) {
if
(
defined
$orig
->{
$key
} !=
defined
$value
|| (
defined
$value
&&
$orig
->{
$key
} ne
$value
)
) {
_print
"# key "
, _qq(
$key
),
" was "
, _qq(
$orig
->{
$key
}),
" now "
, _qq(
$value
),
"\n"
;
$fail
= 1;
}
}
else
{
_print
"# key "
, _qq(
$key
),
" is "
, _qq(
$value
),
", not in original.\n"
;
$fail
= 1;
}
}
foreach
(
keys
%$orig
) {
$_
=
""
.
$_
;
next
if
(
exists
$suspect
->{
$_
});
_print
"# key "
, _qq(
$_
),
" was "
, _qq(
$orig
->{
$_
}),
" now missing.\n"
;
$fail
= 1;
}
!
$fail
;
}
sub
require_ok ($) {
my
(
$require
) =
@_
;
if
(
$require
=~
tr
/[A-Za-z0-9:.]//c) {
fail(
"Invalid character in \"$require\", passed to require_ok"
);
}
else
{
eval
<<REQUIRE_OK;
require $require;
REQUIRE_OK
is($@,
''
, _where(),
"require $require"
);
}
}
sub
use_ok ($) {
my
(
$use
) =
@_
;
if
(
$use
=~
tr
/[A-Za-z0-9:.]//c) {
fail(
"Invalid character in \"$use\", passed to use"
);
}
else
{
eval
<<USE_OK;
use $use;
USE_OK
is($@,
''
, _where(),
"use $use"
);
}
}
my
$is_mswin
= $^O eq
'MSWin32'
;
my
$is_vms
= $^O eq
'VMS'
;
my
$is_cygwin
= $^O eq
'cygwin'
;
sub
_quote_args {
my
(
$runperl
,
$args
) =
@_
;
foreach
(
@$args
) {
$_
=
q(")
.
$_
.
q(")
if
$is_vms
&& !/^\"/ &&
length
(
$_
) > 0;
$runperl
=
$runperl
.
' '
.
$_
;
}
return
$runperl
;
}
sub
_create_runperl {
my
%args
=
@_
;
my
$runperl
= which_perl();
if
(
$runperl
=~ m/\s/) {
$runperl
=
qq{"$runperl"}
;
}
if
(
$ENV
{PERL_RUNPERL_DEBUG}) {
$runperl
=
"$ENV{PERL_RUNPERL_DEBUG} $runperl"
;
}
unless
(
$args
{nolib}) {
$runperl
=
$runperl
.
' "-I../lib" "-I." '
;
}
if
(
$args
{switches}) {
local
$Level
= 2;
die
"test.pl:runperl(): 'switches' must be an ARRAYREF "
. _where()
unless
ref
$args
{switches} eq
"ARRAY"
;
$runperl
= _quote_args(
$runperl
,
$args
{switches});
}
if
(
defined
$args
{prog}) {
die
"test.pl:runperl(): both 'prog' and 'progs' cannot be used "
. _where()
if
defined
$args
{progs};
$args
{progs} = [
split
/\n/,
$args
{prog}, -1]
}
if
(
defined
$args
{progs}) {
die
"test.pl:runperl(): 'progs' must be an ARRAYREF "
. _where()
unless
ref
$args
{progs} eq
"ARRAY"
;
foreach
my
$prog
(@{
$args
{progs}}) {
if
(!
$args
{non_portable}) {
if
(
$prog
=~
tr
/'"//) {
warn
"quotes in prog >>$prog<< are not portable"
;
}
if
(
$prog
=~ /^([<>|]|2>)/) {
warn
"Initial $1 in prog >>$prog<< is not portable"
;
}
if
(
$prog
=~ /&\z/) {
warn
"Trailing & in prog >>$prog<< is not portable"
;
}
}
if
(
$is_mswin
||
$is_vms
) {
$runperl
=
$runperl
.
qq (
-e
"$prog"
);
}
else
{
$runperl
=
$runperl
.
qq (
-e
'$prog'
);
}
}
}
elsif
(
defined
$args
{progfile}) {
$runperl
=
$runperl
.
qq( "$args{progfile}")
;
}
else
{
die
"test.pl:runperl(): none of prog, progs, progfile, args, "
.
" switches or stdin specified"
unless
defined
$args
{args} or
defined
$args
{switches}
or
defined
$args
{stdin};
}
if
(
defined
$args
{stdin}) {
$args
{stdin} =~ s/\n/\\n/g;
$args
{stdin} =~ s/\r/\\r/g;
if
(
$is_mswin
||
$is_vms
) {
$runperl
=
qq{$Perl -e "print qq(}
.
$args
{stdin} .
q{)" | }
.
$runperl
;
}
else
{
$runperl
=
qq{$Perl -e 'print qq(}
.
$args
{stdin} .
q{)' | }
.
$runperl
;
}
}
elsif
(
exists
$args
{stdin}) {
$runperl
=
$runperl
. (
$is_mswin
?
' <nul'
:
' </dev/null'
);
}
if
(
defined
$args
{args}) {
$runperl
= _quote_args(
$runperl
,
$args
{args});
}
if
(
exists
$args
{stderr} &&
$args
{stderr} eq
'devnull'
) {
$runperl
=
$runperl
. (
$is_mswin
?
' 2>nul'
:
' 2>/dev/null'
);
}
elsif
(
$args
{stderr}) {
$runperl
=
$runperl
.
' 2>&1'
;
}
if
(
$args
{verbose}) {
my
$runperldisplay
=
$runperl
;
$runperldisplay
=~ s/\n/\n\
_print_stderr
"# $runperldisplay\n"
;
}
return
$runperl
;
}
sub
untaint_path {
my
$path
=
shift
;
my
$sep
;
if
(!
eval
{
require
Config; 1}) {
warn
"test.pl had problems loading Config: $@"
;
$sep
=
':'
;
}
else
{
$sep
=
$Config::Config
{path_sep};
}
$path
=
join
$sep
,
grep
{
$_
ne
""
and
$_
ne
"."
and -d
$_
and
(
$is_mswin
or
$is_vms
or !(
stat
&& (
stat
_)[2]&0022)) }
split
quotemeta
(
$sep
), $1;
if
(
$is_cygwin
) {
if
(
length
$path
) {
$path
=
$path
.
$sep
;
}
$path
=
$path
.
'/bin'
;
}
elsif
(!
$is_vms
and !
length
$path
) {
$path
=
"/usr/bin"
;
}
$path
;
}
sub
runperl {
die
"test.pl:runperl() does not take a hashref"
if
ref
$_
[0] and
ref
$_
[0] eq
'HASH'
;
my
$runperl
=
&_create_runperl
;
my
$result
;
my
$tainted
= ${^TAINT};
my
%args
=
@_
;
exists
$args
{switches} &&
grep
m/^-T$/, @{
$args
{switches}} and
$tainted
=
$tainted
+ 1;
if
(
$tainted
) {
my
@keys
=
grep
{
exists
$ENV
{
$_
}}
qw(CDPATH IFS ENV BASH_ENV)
;
local
@ENV
{
@keys
} = ();
local
$ENV
{
'DCL$PATH'
} = $1
if
$is_vms
&&
exists
(
$ENV
{
'DCL$PATH'
}) && (
$ENV
{
'DCL$PATH'
} =~ /(.*)/s);
$ENV
{PATH} =~ /(.*)/s;
local
$ENV
{PATH} = untaint_path($1);
$runperl
=~ /(.*)/s;
$runperl
= $1;
$result
= `
$runperl
`;
}
else
{
$result
= `
$runperl
`;
}
$result
=~ s/\n\n/\n/g
if
$is_vms
;
return
$result
;
}
*run_perl
=
*run_perl
= \
&runperl
;
sub
runperl_and_capture {
my
(
$env
,
$args
) =
@_
;
my
$STDOUT
= tempfile();
my
$STDERR
= tempfile();
my
$PERL
= $^X;
my
$FAILURE_CODE
= 119;
local
%ENV
=
%ENV
;
delete
$ENV
{PERLLIB};
delete
$ENV
{PERL5LIB};
delete
$ENV
{PERL5OPT};
delete
$ENV
{PERL_USE_UNSAFE_INC};
my
$pid
=
fork
;
return
(0,
"Couldn't fork: $!"
)
unless
defined
$pid
;
if
(
$pid
) {
waitpid
$pid
,0;
my
$exit_code
= $? ? $? >> 8 : 0;
my
(
$out
,
$err
)= (
""
,
""
);
local
$/;
if
(
open
my
$stdout
,
'<'
,
$STDOUT
) {
$out
.= <
$stdout
>;
}
else
{
$err
.=
"Could not read STDOUT '$STDOUT' file: $!\n"
;
}
if
(
open
my
$stderr
,
'<'
,
$STDERR
) {
$err
.= <
$stderr
>;
}
else
{
$err
.=
"Could not read STDERR '$STDERR' file: $!\n"
;
}
if
(
$exit_code
==
$FAILURE_CODE
) {
$err
.=
"Something went wrong. Received FAILURE_CODE as exit code.\n"
;
}
if
(
$ENV
{DEBUG_RUNENV}) {
print
"OUT: $out\n"
;
print
"ERR: $err\n"
;
}
return
(
$out
,
$err
);
}
elsif
(
defined
$pid
) {
for
my
$k
(
sort
keys
%$env
) {
$ENV
{
$k
} =
$env
->{
$k
};
}
if
(
$ENV
{DEBUG_RUNENV}) {
print
"Child Process $$ Executing:\n$PERL @$args\n"
;
}
open
STDOUT,
'>'
,
$STDOUT
or
do
{
print
"Failed to dup STDOUT to '$STDOUT': $!"
;
exit
$FAILURE_CODE
;
};
open
STDERR,
'>'
,
$STDERR
or
do
{
print
"Failed to dup STDERR to '$STDERR': $!"
;
exit
$FAILURE_CODE
;
};
exec
$PERL
,
@$args
or
print
STDERR
"Failed to exec: "
,
join
(
" "
,
map
{
"'$_'"
} $^X,
@$args
),
": $!\n"
;
exit
$FAILURE_CODE
;
}
}
sub
DIE {
_print_stderr
"# @_\n"
;
exit
1;
}
sub
which_perl {
unless
(
defined
$Perl
) {
$Perl
= $^X;
return
$Perl
if
$is_vms
;
my
$exe
;
if
(!
eval
{
require
Config; 1}) {
warn
"test.pl had problems loading Config: $@"
;
$exe
=
''
;
}
else
{
$exe
=
$Config::Config
{_exe};
}
$exe
=
''
unless
defined
$exe
;
if
(
$Perl
=~ /^perl\Q
$exe
\E$/i) {
my
$perl
=
"perl$exe"
;
warn
"test.pl had problems loading File::Spec: $@"
;
$Perl
=
"./$perl"
;
}
else
{
$Perl
= File::Spec->catfile(File::Spec->curdir(),
$perl
);
}
}
if
(
$Perl
!~ /\Q
$exe
\E$/i) {
$Perl
=
$Perl
.
$exe
;
}
warn
"which_perl: cannot find $Perl from $^X"
unless
-f
$Perl
;
$ENV
{PERLEXE} =
$Perl
;
}
return
$Perl
;
}
sub
unlink_all {
my
$count
= 0;
foreach
my
$file
(
@_
) {
1
while
unlink
$file
;
if
( -f
$file
){
_print_stderr
"# Couldn't unlink '$file': $!\n"
;
}
else
{
$count
=
$count
+ 1;
}
}
$count
;
}
my
@letters
=
qw(A B C D E F G H I J K L M N O P Q R S T U V W X Y Z)
;
sub
_num_to_alpha {
my
(
$num
,
$max_char
) =
@_
;
return
unless
$num
>= 0;
my
$alpha
=
''
;
my
$char_count
= 0;
$max_char
= 0
if
!
defined
(
$max_char
) or
$max_char
< 0;
while
( 1 ){
$alpha
=
$letters
[
$num
%
@letters
] .
$alpha
;
$num
=
int
(
$num
/
@letters
);
last
if
$num
== 0;
$num
=
$num
- 1;
next
unless
$max_char
;
$char_count
=
$char_count
+ 1;
return
if
$char_count
==
$max_char
;
}
return
$alpha
;
}
my
%tmpfiles
;
sub
unlink_tempfiles {
unlink_all
keys
%tmpfiles
;
%tmpfiles
= ();
}
END { unlink_tempfiles(); }
$::tempfile_regexp =
'tmp_[A-Z]+_[A-Z]+'
;
my
$tempfile_count
= 0;
my
$max_file_chars
= 3;
sub
tempfile {
my
$try_prefix
= (-d
"t"
?
"t/"
:
""
).
"tmp_"
._num_to_alpha($$);
while
(1) {
my
$alpha
= _num_to_alpha(
$tempfile_count
,
$max_file_chars
);
last
unless
defined
$alpha
;
my
$try
=
$try_prefix
.
"_"
.
$alpha
;
$tempfile_count
=
$tempfile_count
+ 1;
if
(!
$tmpfiles
{
$try
} && !-e
$try
) {
$tmpfiles
{
$try
} = 1;
return
$try
;
}
}
die
sprintf
'panic: Too many tempfile()s with prefix "%s", limit of %d reached'
,
$try_prefix
, 26 **
$max_file_chars
;
}
sub
register_tempfile {
my
$count
= 0;
for
(
@_
){
if
(
$tmpfiles
{
$_
} ){
_print_stderr
"# Temporary file '$_' already added\n"
;
}
else
{
$tmpfiles
{
$_
} = 1;
$count
=
$count
+ 1;
}
}
return
$count
;
}
my
$tmpfile
= tempfile();
sub
fresh_perl {
my
(
$prog
,
$runperl_args
) =
@_
;
die
sprintf
"Second argument to fresh_perl_.* must be hashref of args to fresh_perl (or {})"
unless
!(
defined
$runperl_args
) ||
ref
(
$runperl_args
) eq
'HASH'
;
my
$trim
=
delete
$runperl_args
->{rtrim_result};
$runperl_args
->{progfile} ||=
$tmpfile
;
$runperl_args
->{stderr} = 1
unless
exists
$runperl_args
->{stderr};
open
TEST,
'>'
,
$tmpfile
or
die
"Cannot open $tmpfile: $!"
;
binmode
TEST,
':utf8'
if
$runperl_args
->{wide_chars};
print
TEST
$prog
;
close
TEST or
die
"Cannot close $tmpfile: $!"
;
my
$results
= runperl(
%$runperl_args
);
my
$status
= $?;
$results
=~s/[ \t]+\n/\n/g
if
$trim
;
$results
=~ s/\n+$//;
$results
=~ s/at\s+$::tempfile_regexp\s+line/at - line/g;
$results
=~ s/of\s+$::tempfile_regexp\s+aborted/of - aborted/g;
$results
=~ s/^(syntax|parse) error/syntax error/mig;
if
(
$is_vms
) {
$results
=~ s/\n?%[A-Z]+-[SIWEF]-[A-Z]+,.*//;
$results
=~ s/\n\n/\n/g;
}
$? =
$status
;
return
$results
;
}
sub
_fresh_perl {
my
(
$prog
,
$action
,
$expect
,
$runperl_args
,
$name
) =
@_
;
local
$Level
=
$Level
+ 1;
$expect
=~s/[[:blank:]]+\n/\n/g
if
$runperl_args
->{rtrim_result};
my
$results
= fresh_perl(
$prog
,
$runperl_args
);
my
$status
= $?;
unless
(
$name
) {
(
my
$first_line
,
$name
) =
$prog
=~ /^((.{1,50}).*)/;
$name
=
$name
.
'...'
if
length
$first_line
>
length
$name
;
}
my
$pass
;
if
(
$action
eq
'eq'
) {
$pass
= is(
$results
,
$expect
,
$name
);
}
elsif
(
$action
eq
'=~'
) {
$pass
= like(
$results
,
$expect
,
$name
);
}
else
{
die
"_fresh_perl can't process action '$action'"
;
}
unless
(
$pass
) {
_diag
"# PROG: \n$prog\n"
;
_diag
"# STATUS: $status\n"
;
}
return
$pass
;
}
sub
fresh_perl_is {
my
(
$prog
,
$expected
,
$runperl_args
,
$name
) =
@_
;
$expected
=~ s/\n+$//;
local
$Level
=
$Level
+ 1;
_fresh_perl(
$prog
,
'eq'
,
$expected
,
$runperl_args
,
$name
);
}
sub
fresh_perl_like {
my
(
$prog
,
$expected
,
$runperl_args
,
$name
) =
@_
;
local
$Level
=
$Level
+ 1;
_fresh_perl(
$prog
,
'=~'
,
$expected
,
$runperl_args
,
$name
);
}
our
$FATAL
;
sub
_setup_one_file {
my
$fh
=
shift
;
my
@these
= (0,
shift
);
my
(
$lineno
,
$current
);
while
(<
$fh
>) {
if
(
$_
eq
"########\n"
) {
if
(
defined
$current
) {
push
@these
,
$lineno
,
$current
;
}
undef
$current
;
}
else
{
if
(!
defined
$current
) {
$lineno
= $.;
}
$current
.=
$_
;
}
}
if
(
defined
$current
) {
push
@these
,
$lineno
,
$current
;
}
((
scalar
@these
) / 2 - 1,
@these
);
}
sub
setup_multiple_progs {
my
(
$tests
,
@prgs
);
foreach
my
$file
(
@_
) {
next
if
$file
=~ /(?:~|\.orig|,v)$/;
next
if
$file
=~ /perlio$/ && !PerlIO::Layer->find(
'perlio'
);
next
if
-d
$file
;
open
my
$fh
,
'<'
,
$file
or
die
"Cannot open $file: $!\n"
;
my
$found
;
while
(<
$fh
>) {
if
(/^__END__/) {
$found
=
$found
+ 1;
last
;
}
}
die
"Could not find '__END__' in $file"
unless
$found
;
my
(
$t
,
@p
) = _setup_one_file(
$fh
,
$file
);
$tests
+=
$t
;
push
@prgs
,
@p
;
close
$fh
or
die
"Cannot close $file: $!\n"
;
}
return
(
$tests
,
@prgs
);
}
sub
run_multiple_progs {
my
$up
=
shift
;
my
@prgs
;
if
(
$up
) {
@prgs
=
@_
;
}
else
{
my
$dummy
;
(
$dummy
,
@prgs
) = _setup_one_file(
shift
);
}
my
$taint_disabled
;
if
(!
eval
{
require
Config; 1}) {
warn
"test.pl had problems loading Config: $@"
;
$taint_disabled
=
''
;
}
else
{
$taint_disabled
=
$Config::Config
{taint_disabled};
}
my
$tmpfile
= tempfile();
my
$count_failures
= 0;
my
(
$file
,
$line
);
PROGRAM:
while
(
defined
(
$line
=
shift
@prgs
)) {
$_
=
shift
@prgs
;
unless
(
$line
) {
$file
=
$_
;
if
(
defined
$file
) {
print
"# From $file\n"
;
}
next
;
}
my
$switch
=
""
;
my
@temps
;
my
@temp_path
;
if
(s/^(\s*-\w+)//) {
$switch
= $1;
}
s/^
s/([<=>])CONFLICT\1/$1 x 7/ge;
my
(
$prog
,
$expected
) =
split
(/\nEXPECT(?:\n|$)/,
$_
, 2);
my
%reason
;
foreach
my
$what
(
qw(skip todo)
) {
$prog
=~ s/^
if
(
$reason
{
$what
} &&
$reason
{
$what
} =~ s/^\?//) {
my
$temp
=
eval
$reason
{
$what
};
if
($@) {
die
"# In \U$what\E code reason:\n# $reason{$what}\n$@"
;
}
$reason
{
$what
} =
$temp
;
}
}
my
$name
=
''
;
if
(
$prog
=~ s/^
$name
= $1;
}
elsif
(
defined
$file
) {
$name
=
"test from $file at line $line"
;
}
if
(
$switch
=~/[Tt]/ and
$taint_disabled
eq
"define"
) {
$reason
{skip} ||=
"This perl does not support taint"
;
}
if
(
$reason
{skip}) {
SKIP:
{
skip(
$name
?
"$name - $reason{skip}"
:
$reason
{skip}, 1);
}
next
PROGRAM;
}
if
(
$prog
=~ /--FILE--/) {
my
@files
=
split
(/\n?--FILE--\s*([^\s\n]*)\s*\n/,
$prog
) ;
shift
@files
;
die
"Internal error: test $_ didn't split into pairs, got "
.
scalar
(
@files
) .
"["
.
join
(
"%%%%"
,
@files
) .
"]\n"
if
@files
% 2;
while
(
@files
> 2) {
my
$filename
=
shift
@files
;
my
$code
=
shift
@files
;
push
@temps
,
$filename
;
if
(
$filename
=~ m
File::Path::mkpath($1);
push
(
@temp_path
, $1);
}
open
my
$fh
,
'>'
,
$filename
or
die
"Cannot open $filename: $!\n"
;
print
$fh
$code
;
close
$fh
or
die
"Cannot close $filename: $!\n"
;
}
shift
@files
;
$prog
=
shift
@files
;
}
open
my
$fh
,
'>'
,
$tmpfile
or
die
"Cannot open >$tmpfile: $!"
;
print
$fh
q{
BEGIN {
push @INC, '.';
open STDERR, '>&', STDOUT
or die "Can't dup STDOUT->STDERR: $!;";
}
};
print
$fh
"\n#line 1\n"
; # So the line numbers don't get messed up.
print
$fh
$prog
,
"\n"
;
close
$fh
or
die
"Cannot close $tmpfile: $!"
;
my
$results
= runperl(
stderr
=> 1,
progfile
=>
$tmpfile
,
stdin
=>
undef
,
$up
? (
switches
=> [
"-I$up/lib"
,
$switch
],
nolib
=> 1)
: (
switches
=> [
$switch
])
);
my
$status
= $?;
$results
=~ s/\n+$//;
$results
=~ s/$::tempfile_regexp/-/g;
if
($^O eq
'VMS'
) {
$results
=~ s/\n?%[A-Z]+-[SIWEF]-[A-Z]+,.*//;
$results
=~ s/\n\n/\n/g;
}
$results
=~ s/^(syntax|parse) error/syntax error/mig;
$results
=~ s/Scalars leaked: \d+\n//g;
$expected
=~ s/\n+$//;
my
$prefix
= (
$results
=~ s
my
$option_regex
= 0;
my
$option_random
= 0;
my
$fatal
=
$FATAL
;
if
(
$expected
=~ s/^OPTIONS? (.+)(?:\n|\Z)//) {
foreach
my
$option
(
split
(
' '
, $1)) {
if
(
$option
eq
'regex'
) {
$option_regex
= 1;
}
elsif
(
$option
eq
'random'
) {
$option_random
= 1;
}
elsif
(
$option
eq
'fatal'
) {
$fatal
= 1;
}
elsif
(
$option
eq
'nonfatal'
) {
$fatal
= 0;
}
else
{
die
"$0: Unknown OPTION '$option'\n"
;
}
}
}
die
"$0: can't have OPTION regex and random\n"
if
$option_regex
+
$option_random
> 1;
my
$ok
= 0;
if
(
$results
=~ s/^SKIPPED\n//) {
print
"$results\n"
;
$ok
= 1;
}
else
{
if
(
$option_random
) {
my
@got
=
sort
split
"\n"
,
$results
;
my
@expected
=
sort
split
"\n"
,
$expected
;
$ok
=
"@got"
eq
"@expected"
;
}
elsif
(
$option_regex
) {
$ok
=
$results
=~ /^
$expected
/;
}
elsif
(
$prefix
) {
$ok
=
$results
=~ /^\Q
$expected
/;
}
else
{
$ok
=
$results
eq
$expected
;
}
if
(
$ok
&&
$fatal
&& !(
$status
>> 8)) {
$ok
= 0;
}
}
local
$::TODO =
$reason
{todo};
unless
(
$ok
) {
my
$err_line
=
''
;
$err_line
.=
"FILE: $file ; line $line\n"
if
defined
$file
;
$err_line
.=
"PROG: $switch\n$prog\n"
.
"EXPECTED:\n$expected\n"
;
$err_line
.=
"EXIT STATUS: != 0\n"
if
$fatal
;
$err_line
.=
"GOT:\n$results\n"
;
$err_line
.=
"EXIT STATUS: "
. (
$status
>> 8) .
"\n"
if
$fatal
;
if
($::TODO) {
$err_line
=~ s/^/
print
$err_line
;
}
else
{
print
STDERR
$err_line
;
++
$count_failures
;
die
"PERL_TEST_ABORT_FIRST_FAILURE set Test Failure"
if
$ENV
{PERL_TEST_ABORT_FIRST_FAILURE};
}
}
if
(
defined
$file
) {
_ok(
$ok
,
"at $file line $line"
,
$name
);
}
else
{
local
$Level
=
$Level
+ 1;
ok(
$ok
,
$name
);
}
foreach
(
@temps
) {
unlink
$_
if
$_
;
}
foreach
(
@temp_path
) {
File::Path::rmtree
$_
if
-d
$_
;
}
}
if
(
$count_failures
) {
print
STDERR
<<'EOS';
#
# Note: 'run_multiple_progs' run has one or more failures
# you can consider setting the environment variable
# PERL_TEST_ABORT_FIRST_FAILURE=1 before running the test
# to stop on the first error.
#
EOS
}
return
;
}
sub
can_ok ($@) {
my
(
$proto
,
@methods
) =
@_
;
my
$class
=
ref
$proto
||
$proto
;
unless
(
@methods
) {
return
_ok( 0, _where(),
"$class->can(...)"
);
}
my
@nok
= ();
foreach
my
$method
(
@methods
) {
local
($!, $@);
eval
{
$proto
->can(
$method
) } ||
push
@nok
,
$method
;
}
my
$name
;
$name
=
@methods
== 1 ?
"$class->can('$methods[0]')"
:
"$class->can(...)"
;
_ok( !
@nok
, _where(),
$name
);
}
sub
new_ok {
my
(
$class
,
$args
,
$obj_name
) =
@_
;
$args
||= [];
$obj_name
=
"The object"
unless
defined
$obj_name
;
local
$Level
=
$Level
+ 1;
my
$obj
;
my
$ok
=
eval
{
$obj
=
$class
->new(
@$args
); 1 };
my
$error
= $@;
if
(
$ok
) {
object_ok(
$obj
,
$class
,
$obj_name
);
}
else
{
ok( 0,
"new() died"
);
diag(
"Error was: $@"
);
}
return
$obj
;
}
sub
isa_ok ($$;$) {
my
(
$object
,
$class
,
$obj_name
) =
@_
;
my
$diag
;
$obj_name
=
'The object'
unless
defined
$obj_name
;
my
$name
=
"$obj_name isa $class"
;
if
( !
defined
$object
) {
$diag
=
"$obj_name isn't defined"
;
}
else
{
my
$whatami
=
ref
$object
?
'object'
:
'class'
;
local
($@, $!);
my
$rslt
=
eval
{
$object
->isa(
$class
) };
my
$error
= $@;
if
(
$error
) {
if
(
$error
=~ /^Can't call method
"isa"
on unblessed reference/ ) {
$obj_name
=
'The reference'
unless
defined
$obj_name
;
if
( !UNIVERSAL::isa(
$object
,
$class
) ) {
my
$ref
=
ref
$object
;
$diag
=
"$obj_name isn't a '$class' it's a '$ref'"
;
}
}
elsif
(
$error
=~ /Can't call method
"isa"
without a
package
/ ) {
$obj_name
=
'The thing'
unless
defined
$obj_name
;
$diag
=
"$obj_name isn't a class or reference"
;
}
else
{
die
<<WHOA;
WHOA! I tried to call ->isa on your object and got some weird error.
This should never happen. Please contact the author immediately.
Here's the error.
$@
WHOA
}
}
elsif
( !
$rslt
) {
$obj_name
=
"The $whatami"
unless
defined
$obj_name
;
my
$ref
=
ref
$object
;
$diag
=
"$obj_name isn't a '$class' it's a '$ref'"
;
}
}
_ok( !
$diag
, _where(),
$name
);
}
sub
class_ok {
my
(
$class
,
$isa
,
$class_name
) =
@_
;
local
$Level
=
$Level
+ 1;
if
(
ref
$class
) {
ok( 0,
"$class is a reference, not a class name"
);
}
else
{
isa_ok(
$class
,
$isa
,
$class_name
);
}
}
sub
object_ok {
my
(
$obj
,
$isa
,
$obj_name
) =
@_
;
local
$Level
=
$Level
+ 1;
if
( !
ref
$obj
) {
ok( 0,
"$obj is not a reference"
);
}
else
{
isa_ok(
$obj
,
$isa
,
$obj_name
);
}
}
sub
__capture {
push
@::__capture,
join
""
,
@_
;
}
sub
capture_warnings {
my
$code
=
shift
;
local
@::__capture;
local
$SIG
{__WARN__} = \
&__capture
;
local
$Level
= 1;
&$code
;
return
@::__capture;
}
sub
warnings_like {
my
(
$code
,
$expect
,
$name
) =
@_
;
local
$Level
=
$Level
+ 1;
my
@w
= capture_warnings(
$code
);
cmp_ok(
scalar
@w
,
'=='
,
scalar
@$expect
,
$name
);
foreach
my
$e
(
@$expect
) {
if
(
ref
$e
) {
like(
shift
@w
,
$e
,
$name
);
}
else
{
is(
shift
@w
,
$e
,
$name
);
}
}
if
(
@w
) {
diag(
"Saw these additional warnings:"
);
diag(
$_
)
foreach
@w
;
}
}
sub
_fail_excess_warnings {
my
(
$expect
,
$got
,
$name
) =
@_
;
local
$Level
=
$Level
+ 1;
is(
$expect
,
scalar
@$got
,
$name
);
diag(
"Saw these warnings:"
);
diag(
$_
)
foreach
@$got
;
}
sub
warning_is {
my
(
$code
,
$expect
,
$name
) =
@_
;
die
sprintf
"Expect must be a string or undef, not a %s reference"
,
ref
$expect
if
ref
$expect
;
local
$Level
=
$Level
+ 1;
my
@w
= capture_warnings(
$code
);
if
(
@w
> 1) {
_fail_excess_warnings(0 +
defined
$expect
, \
@w
,
$name
);
}
else
{
is(
$w
[0],
$expect
,
$name
);
}
}
sub
warning_like {
my
(
$code
,
$expect
,
$name
) =
@_
;
die
sprintf
"Expect must be a regexp object"
unless
ref
$expect
eq
'Regexp'
;
local
$Level
=
$Level
+ 1;
my
@w
= capture_warnings(
$code
);
if
(
@w
> 1) {
_fail_excess_warnings(0 +
defined
$expect
, \
@w
,
$name
);
}
else
{
like(
$w
[0],
$expect
,
$name
);
}
}
{
my
$watchdog
;
my
$watchdog_thread
;
sub
watchdog ($;$)
{
my
$timeout
=
shift
;
if
(
$timeout
== 0) {
if
(
$watchdog_thread
) {
$watchdog_thread
->
kill
(
'KILL'
);
undef
$watchdog_thread
;
}
elsif
(
$watchdog
) {
kill
(
'KILL'
,
$watchdog
);
undef
$watchdog
;
}
else
{
alarm
(0);
}
return
;
}
undef
$watchdog
;
undef
$watchdog_thread
;
my
$method
=
shift
||
""
;
my
$timeout_msg
=
'Test process timed out - terminating'
;
my
$timeout_factor
=
$ENV
{PERL_TEST_TIME_OUT_FACTOR}
||
$ENV
{PERL_TEST_TIMEOUT_FACTOR}
|| 1;
$timeout_factor
= 1
if
$timeout_factor
< 1;
$timeout_factor
= $1
if
$timeout_factor
=~ /^(\d+)$/;
$timeout_factor
= 10
if
$timeout_factor
< 10 &&
$ENV
{PERL_VALGRIND};
$timeout
*=
$timeout_factor
;
my
$pid_to_kill
= $$;
if
(
$method
eq
"alarm"
) {
goto
WATCHDOG_VIA_ALARM;
}
my
$threads_on
=
$threads::threads
&&
$threads::threads
;
if
(!
$threads_on
||
$method
eq
"process"
) {
if
(
$is_mswin
||
$is_vms
) {
if
(
$is_mswin
) {
if
(
defined
(
&Win32::GetCurrentProcessId
)) {
$pid_to_kill
= Win32::GetCurrentProcessId();
}
}
return
if
(
$pid_to_kill
<= 0);
undef
$watchdog
;
eval
{
local
$SIG
{
'__WARN__'
} =
sub
{
_diag(
"Watchdog warning: $_[0]"
);
};
my
$sig
=
$is_vms
?
'TERM'
:
'KILL'
;
my
$prog
=
"sleep($timeout);"
.
"warn qq/# $timeout_msg"
.
'\n/;'
.
"kill(q/$sig/, $pid_to_kill);"
;
$ENV
{PATH} =~ /(.*)/s;
local
$ENV
{PATH} = untaint_path($1);
if
(
$is_mswin
) {
my
$runperl
= which_perl();
$runperl
=~ /(.*)/;
$runperl
= $1;
if
(
$runperl
=~ m/\s/) {
$runperl
=
qq{"$runperl"}
;
}
$watchdog
=
system
({
$runperl
} 1,
$runperl
,
'-e'
,
$prog
);
}
else
{
my
$cmd
= _create_runperl(
prog
=>
$prog
);
$watchdog
=
system
(1,
$cmd
);
}
};
if
($@ || (
$watchdog
<= 0)) {
_diag(
'Failed to start watchdog'
);
_diag($@)
if
$@;
undef
(
$watchdog
);
return
;
}
eval
("END {
local
\$! = 0;
local
\$? = 0;
wait
()
if
kill
(
'KILL'
,
$watchdog
); };");
return
;
}
undef
$watchdog
;
eval
{
$watchdog
=
fork
() };
if
(
defined
(
$watchdog
)) {
if
(
$watchdog
) {
eval
"END {
local
\$! = 0;
local
\$? = 0;
wait
()
if
kill
(
'KILL'
,
$watchdog
); };";
return
;
}
sleep
(
$timeout
- 2)
if
(
$timeout
> 2);
sleep
(2);
if
(
kill
(0,
$pid_to_kill
)) {
_diag(
$timeout_msg
);
kill
(
'KILL'
,
$pid_to_kill
);
if
(
$is_cygwin
) {
sleep
1;
system
(
"/bin/kill -f $pid_to_kill"
)
if
kill
(0,
$pid_to_kill
);
}
}
$NO_ENDING
= 1;
POSIX::_exit(1)
if
(
defined
(
&POSIX::_exit
));
exit
(1);
}
}
$watchdog_thread
=
'threads'
->create(
sub
{
$SIG
{
'KILL'
} =
sub
{ threads->
exit
(); };
'threads'
->detach();
my
$time_left
=
$timeout
;
do
{
$time_left
=
$time_left
-
sleep
(
$time_left
);
}
while
(
$time_left
> 0);
select
(STDERR); $| = 1;
_diag(
$timeout_msg
);
POSIX::_exit(1)
if
(
defined
(
&POSIX::_exit
));
my
$sig
=
$is_vms
?
'TERM'
:
'KILL'
;
kill
(
$sig
,
$pid_to_kill
);
});
while
(
$watchdog_thread
->is_running()
&& !
$watchdog_thread
->is_detached())
{
'threads'
->yield();
}
return
;
}
WATCHDOG_VIA_ALARM:
if
(
eval
{
alarm
(
$timeout
); 1; }) {
$SIG
{
'ALRM'
} =
sub
{
select
(STDERR); $| = 1;
_diag(
$timeout_msg
);
POSIX::_exit(1)
if
(
defined
(
&POSIX::_exit
));
my
$sig
=
$is_vms
?
'TERM'
:
'KILL'
;
kill
(
$sig
,
$pid_to_kill
);
};
}
}
}
sub
is_linux_container {
if
($^O eq
'linux'
&&
open
my
$fh
,
'<'
,
'/proc/1/cgroup'
) {
while
(<
$fh
>) {
if
(m{^\d+:pids:(.*)} && $1 ne
'/init.scope'
) {
return
1;
}
}
}
return
0;
}
1;